# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

inner_dilate_erode <- function(Filter, replace_Val, i, j, method, image) {
    .Call(`_OpenImageR_inner_dilate_erode`, Filter, replace_Val, i, j, method, image)
}

diate_erode <- function(image, Filter, method = 1L, threads = 1L) {
    .Call(`_OpenImageR_diate_erode`, image, Filter, method, threads)
}

diate_erode_cube <- function(image, Filter, method = 1L, threads = 1L) {
    .Call(`_OpenImageR_diate_erode_cube`, image, Filter, method, threads)
}

#' convert an RGB image to Gray
#' 
#' @param RGB_image a 3-dimensional array
#' @return a matrix
#' @author Lampros Mouselimis
#' @details
#' This function converts an RGB image to gray
#' @export
#' @examples
#' 
#' path = system.file("tmp_images", "1.png", package = "OpenImageR")
#' 
#' image = readImage(path)
#' 
#' gray = rgb_2gray(image)
rgb_2gray <- function(RGB_image) {
    .Call(`_OpenImageR_rgb_2gray`, RGB_image)
}

Gabor_Filter_Bank <- function(u, v, m, n, plot_data = FALSE) {
    .Call(`_OpenImageR_Gabor_Filter_Bank`, u, v, m, n, plot_data)
}

Gabor_export_Features <- function(img, d1, d2, u, v, m, n, downsample_vec = FALSE, plot_data = FALSE, normalize_features = FALSE, threads = 1L) {
    .Call(`_OpenImageR_Gabor_export_Features`, img, d1, d2, u, v, m, n, downsample_vec, plot_data, normalize_features, threads)
}

Gabor_generate <- function(img_data, img_nrow, img_ncol, d1, d2, u, v, m, n, downsample_vec = FALSE, normalize_features = FALSE, threads = 1L) {
    .Call(`_OpenImageR_Gabor_generate`, img_data, img_nrow, img_ncol, d1, d2, u, v, m, n, downsample_vec, normalize_features, threads)
}

hog_cpp <- function(image, n_divs = 3L, n_bins = 6L) {
    .Call(`_OpenImageR_hog_cpp`, image, n_divs, n_bins)
}

inner_hog_mat <- function(x, i, height, width, n_divs, n_bins) {
    .Call(`_OpenImageR_inner_hog_mat`, x, i, height, width, n_divs, n_bins)
}

HOG_matrix <- function(x, height, width, n_divs = 3L, n_bins = 6L, threads = 1L) {
    .Call(`_OpenImageR_HOG_matrix`, x, height, width, n_divs, n_bins, threads)
}

inner_hog_array <- function(x, n_divs, n_bins, i) {
    .Call(`_OpenImageR_inner_hog_array`, x, n_divs, n_bins, i)
}

HOG_array <- function(x, n_divs = 3L, n_bins = 6L, threads = 1L) {
    .Call(`_OpenImageR_HOG_array`, x, n_divs, n_bins, threads)
}

round_rcpp <- function(f, decimal_places = 5L) {
    .Call(`_OpenImageR_round_rcpp`, f, decimal_places)
}

binary_to_hex <- function(x) {
    .Call(`_OpenImageR_binary_to_hex`, x)
}

levenshtein_dist <- function(s, t) {
    .Call(`_OpenImageR_levenshtein_dist`, s, t)
}

func_dct <- function(x) {
    .Call(`_OpenImageR_func_dct`, x)
}

dct_2d <- function(x) {
    .Call(`_OpenImageR_dct_2d`, x)
}

phash_binary <- function(gray_image, hash_size = 8L, highfreq_factor = 4L, resize_method = "nearest") {
    .Call(`_OpenImageR_phash_binary`, gray_image, hash_size, highfreq_factor, resize_method)
}

phash_string <- function(gray_image, hash_size = 8L, highfreq_factor = 4L, resize_method = "nearest") {
    .Call(`_OpenImageR_phash_string`, gray_image, hash_size, highfreq_factor, resize_method)
}

average_hash_binary <- function(gray_image, hash_size = 8L, resize_method = "nearest") {
    .Call(`_OpenImageR_average_hash_binary`, gray_image, hash_size, resize_method)
}

average_hash_string <- function(gray_image, hash_size = 8L, resize_method = "nearest") {
    .Call(`_OpenImageR_average_hash_string`, gray_image, hash_size, resize_method)
}

dhash_binary <- function(gray_image, hash_size = 8L, resize_method = "nearest") {
    .Call(`_OpenImageR_dhash_binary`, gray_image, hash_size, resize_method)
}

dhash_string <- function(gray_image, hash_size = 8L, resize_method = "nearest") {
    .Call(`_OpenImageR_dhash_string`, gray_image, hash_size, resize_method)
}

inner_hash_im <- function(x, i, new_width, new_height, method, hash_size, highfreq_factor, resize_method) {
    .Call(`_OpenImageR_inner_hash_im`, x, i, new_width, new_height, method, hash_size, highfreq_factor, resize_method)
}

hash_image <- function(x, new_width, new_height, resize_method, hash_size = 8L, highfreq_factor = 4L, method = 1L, threads = 1L) {
    .Call(`_OpenImageR_hash_image`, x, new_width, new_height, resize_method, hash_size, highfreq_factor, method, threads)
}

inner_hash_im_cube <- function(x, i, method, hash_size, highfreq_factor, resize_method) {
    .Call(`_OpenImageR_inner_hash_im_cube`, x, i, method, hash_size, highfreq_factor, resize_method)
}

hash_image_cube <- function(x, resize_method, hash_size = 8L, highfreq_factor = 4L, method = 1L, threads = 1L) {
    .Call(`_OpenImageR_hash_image_cube`, x, resize_method, hash_size, highfreq_factor, method, threads)
}

list_2array_convert <- function(x) {
    .Call(`_OpenImageR_list_2array_convert`, x)
}

inner_hash_im_hex <- function(x, i, new_width, new_height, resize_method, hash_size, highfreq_factor, method) {
    .Call(`_OpenImageR_inner_hash_im_hex`, x, i, new_width, new_height, resize_method, hash_size, highfreq_factor, method)
}

hash_image_hex <- function(x, new_width, new_height, resize_method, hash_size = 8L, highfreq_factor = 4L, method = 1L, threads = 1L) {
    .Call(`_OpenImageR_hash_image_hex`, x, new_width, new_height, resize_method, hash_size, highfreq_factor, method, threads)
}

inner_hash_im_cube_hex <- function(x, i, resize_method, hash_size, highfreq_factor, method) {
    .Call(`_OpenImageR_inner_hash_im_cube_hex`, x, i, resize_method, hash_size, highfreq_factor, method)
}

hash_image_cube_hex <- function(x, resize_method, hash_size = 8L, highfreq_factor = 4L, method = 1L, threads = 1L) {
    .Call(`_OpenImageR_hash_image_cube_hex`, x, resize_method, hash_size, highfreq_factor, method, threads)
}

mod <- function(a, b) {
    .Call(`_OpenImageR_mod`, a, b)
}

indices <- function(rows, cols) {
    .Call(`_OpenImageR_indices`, rows, cols)
}

vec2mat <- function(V, mat_rows, mat_cols) {
    .Call(`_OpenImageR_vec2mat`, V, mat_rows, mat_cols)
}

seq_rcpp <- function(x) {
    .Call(`_OpenImageR_seq_rcpp`, x)
}

resize_nearest_rcpp <- function(image, width, height) {
    .Call(`_OpenImageR_resize_nearest_rcpp`, image, width, height)
}

resize_nearest_array <- function(image, width, height) {
    .Call(`_OpenImageR_resize_nearest_array`, image, width, height)
}

indices_bilinear <- function(rows, cols) {
    .Call(`_OpenImageR_indices_bilinear`, rows, cols)
}

meshgrid_x <- function(rows, cols) {
    .Call(`_OpenImageR_meshgrid_x`, rows, cols)
}

meshgrid_y <- function(rows, cols) {
    .Call(`_OpenImageR_meshgrid_y`, rows, cols)
}

replaceVal <- function(x, thresh, value, mode = 1L) {
    .Call(`_OpenImageR_replaceVal`, x, thresh, value, mode)
}

vec2mat_colwise <- function(VEC, mat_rows, mat_cols) {
    .Call(`_OpenImageR_vec2mat_colwise`, VEC, mat_rows, mat_cols)
}

Vectz <- function(x) {
    .Call(`_OpenImageR_Vectz`, x)
}

resize_bilinear_rcpp <- function(image, width, height) {
    .Call(`_OpenImageR_resize_bilinear_rcpp`, image, width, height)
}

bilinear_array <- function(image, width, height) {
    .Call(`_OpenImageR_bilinear_array`, image, width, height)
}

Array_range <- function(x, mode = 1L) {
    .Call(`_OpenImageR_Array_range`, x, mode)
}

Normalize_array <- function(x) {
    .Call(`_OpenImageR_Normalize_array`, x)
}

Normalize_matrix <- function(x) {
    .Call(`_OpenImageR_Normalize_matrix`, x)
}

rotate_rcpp <- function(image, angle) {
    .Call(`_OpenImageR_rotate_rcpp`, image, angle)
}

seq_rcpp_range <- function(start, end) {
    .Call(`_OpenImageR_seq_rcpp_range`, start, end)
}

inner_bilinear <- function(t, s, image, method, n, m, mm, nn, thet) {
    .Call(`_OpenImageR_inner_bilinear`, t, s, image, method, n, m, mm, nn, thet)
}

rotate_nearest_bilinear <- function(image, angle, method, mode, threads) {
    .Call(`_OpenImageR_rotate_nearest_bilinear`, image, angle, method, mode, threads)
}

rotate_nearest_bilinear_array_same <- function(src, angle, method, threads) {
    .Call(`_OpenImageR_rotate_nearest_bilinear_array_same`, src, angle, method, threads)
}

rotate_nearest_bilinear_array_full <- function(src, angle, method, threads) {
    .Call(`_OpenImageR_rotate_nearest_bilinear_array_full`, src, angle, method, threads)
}

conv2d <- function(image, kernel, mode) {
    .Call(`_OpenImageR_conv2d`, image, kernel, mode)
}

conv3d <- function(image, kernel, mode) {
    .Call(`_OpenImageR_conv3d`, image, kernel, mode)
}

svd_arma_econ <- function(m) {
    .Call(`_OpenImageR_svd_arma_econ`, m)
}

removeMean <- function(data) {
    .Call(`_OpenImageR_removeMean`, data)
}

zca_whitening <- function(data, k, epsilon) {
    .Call(`_OpenImageR_zca_whitening`, data, k, epsilon)
}

zca_whiten_cube <- function(src, k, epsilon) {
    .Call(`_OpenImageR_zca_whiten_cube`, src, k, epsilon)
}

im_flip <- function(x, mode = 1L) {
    .Call(`_OpenImageR_im_flip`, x, mode)
}

im_flip_cube <- function(src, mode = 1L) {
    .Call(`_OpenImageR_im_flip_cube`, src, mode)
}

translation_mat <- function(image, shift_rows = 0L, shift_cols = 0L, FILL_VALUE = 0.0) {
    .Call(`_OpenImageR_translation_mat`, image, shift_rows, shift_cols, FILL_VALUE)
}

augment_transf <- function(image, flip_mode, crop_height, crop_width, resiz_width = 0.0, resiz_height = 0.0, resiz_method = "nearest", shift_rows = 0.0, shift_cols = 0.0, rotate_angle = 0.0, rotate_method = "nearest", zca_comps = 0L, zca_epsilon = 0.0, image_thresh = 0.0, pad_shift_value = 0.0) {
    .Call(`_OpenImageR_augment_transf`, image, flip_mode, crop_height, crop_width, resiz_width, resiz_height, resiz_method, shift_rows, shift_cols, rotate_angle, rotate_method, zca_comps, zca_epsilon, image_thresh, pad_shift_value)
}

augment_transf_array <- function(image, flip_mode, crop_height, crop_width, pad_shift_value, resiz_width = 0.0, resiz_height = 0.0, resiz_method = "nearest", shift_rows = 0.0, shift_cols = 0.0, rotate_angle = 0.0, rotate_method = "nearest", zca_comps = 0L, zca_epsilon = 0.0, image_thresh = 0.0) {
    .Call(`_OpenImageR_augment_transf_array`, image, flip_mode, crop_height, crop_width, pad_shift_value, resiz_width, resiz_height, resiz_method, shift_rows, shift_cols, rotate_angle, rotate_method, zca_comps, zca_epsilon, image_thresh)
}

augment_array_list <- function(x, flip_mode, crop_height, crop_width, pad_shift_value, resiz_width = 0.0, resiz_height = 0.0, resiz_method = "nearest", shift_rows = 0.0, shift_cols = 0.0, rotate_angle = 0.0, rotate_method = "nearest", zca_comps = 0L, zca_epsilon = 0.0, image_thresh = 0.0) {
    .Call(`_OpenImageR_augment_array_list`, x, flip_mode, crop_height, crop_width, pad_shift_value, resiz_width, resiz_height, resiz_method, shift_rows, shift_cols, rotate_angle, rotate_method, zca_comps, zca_epsilon, image_thresh)
}

MinMaxArray <- function(x) {
    .Call(`_OpenImageR_MinMaxArray`, x)
}

MinMaxMatrix <- function(x) {
    .Call(`_OpenImageR_MinMaxMatrix`, x)
}

